ad_rtepasteplain = {
	
	doc: null,
	
	init: function() {	
		
		setTimeout(function() {
			try {			
				var editorId = "editorWrap"+ editornumber;												
				var container = document.getElementById(editorId);
							
				var iframeEl = container.getElementsByTagName("iframe")[0];
				
				if (iframeEl.contentDocument ) { // DOM
				    doc = iframeEl.contentDocument;
				} else if ( iframeEl.contentWindow ) { // IE
				    doc = iframeEl.contentWindow.document;
				}						
				
				if(!ad_rtepasteplain.addEvent(doc, "paste", ad_rtepasteplain.handleEvent, false)) {
					ad_rtepasteplain.addEvent(doc, "keydown", ad_rtepasteplain.handleEvent, false);
				}				
				
				ad_rtepasteplain.doc = doc;
						
			} catch(e) { }
			
		}, 1000);
	
	},
	
	addEvent: function(el, eType, fn, uC) {
		if (el.addEventListener) {
			el.addEventListener(eType, fn, uC);
			return true;
		} else if(el.attachEvent) {
			el.attachEvent('on' + eType, fn);			
		} else {
			el['on' + eType] = fn;			 
		}
		var ret = el['on' + eType];
		if(ret == "undefined")
			ret = false; 
		return ret;
	},

	handleEvent: function(e) {
		
		e = e || window.event;				
		if(
			(e.type == "paste") ||
			((e.ctrlKey || e.metaKey) && e.keyCode == 86)
		) {	
			
			var text;
			
			if(text = ad_rtepasteplain.getClipboardText()) {
				ad_rtepasteplain.doInsertText(ad_rtepasteplain.doc, text);
				return false;
			} else {									
				// Clipboard access failed		
				ad_rtepasteplain.openHelperWindow();						
			}
			
			if(e && e.preventDefault) {
		        e.preventDefault();
		    } else if(e.returnValue) {
		        e.returnValue = false;
		    }
			return false;							
		}		
	},		
			
	getClipboardText: function() {
		
		var clipboardText = null;
		
		try {
			clipboardText = window.clipboardData.getData('Text');
		} catch(e) { 
		
		}
				
		if(!clipboardText) {
	
			try {
			
				window.netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
				
				var clip = window.Components.classes["@mozilla.org/widget/clipboard;1"].getService(window.Components.interfaces.nsIClipboard);
				var trans = window.Components.classes["@mozilla.org/widget/transferable;1"].createInstance(window.Components.interfaces.nsITransferable);
				trans.addDataFlavor("text/unicode");
				clip.getData(trans, clip.kGlobalClipboard);
				
				var str = {}, strLength = {}, clipboardText;
				trans.getTransferData("text/unicode", str, strLength);
				str = str.value.QueryInterface(window.Components.interfaces.nsISupportsString);
				clipboardText = str.data.substring(0, strLength.value / 2);					
			} catch(e) { 
			
			}			
		}	
		
		return clipboardText;
	
	},
	
	openHelperWindow: function() {
		var file 	= ad_rtepasteplain_extPath + "res/helper.html";
		var title 	= ad_rtepasteplain_labels.popup.title;	
		var win = window.open(file, title, "width=400,height=280,scrollbars=yes,dependent=yes,location=no,menubar=no,resizable=yes,status=yes,toolbar=no");
		win.focus();
	},		
	
	doInsertText: function(doc, text) {		
		try	{
			var selection = doc.selection;
			if ( selection.type == 'Control' )
				selection.clear();
			selection.createRange().pasteHTML( text );
		} catch(e) {
			doc.execCommand( "inserthtml", false, text );
		}					
	}
	
};

ad_rtepasteplain.addEvent(window, "load", ad_rtepasteplain.init, false);